;
;	Claudio Rivoira 22/12/2002
;
;
;   Versione per AUTOCAD 12 o Superiore  I T A L I A N O / I N G L E S E
;
;
;      _________________________________________________________________
;      |                                                               |
;      |   ACQUISIZIONE DEI DATI CON L'UTILIZZO DI SUBRURINE           |
;      |                                                               |
;      
;
;
;---------------------------------
;  Input Variabili ambiente
;---------------------------------
(defun MODES (a)
   (setq mlst '())				; Inizializza lista (lista vuota)
   (repeat (length a)				; Ripete per tutta la lunghezza della lista
      (setq mlst (append mlst (list (list (car a) (getvar (car a))))))
      (setq a (cdr a))				; Accorcia lista eliminando primo elemento
   )
)
;-----------------------------------
;  Ripristina variabili ambiente
;-----------------------------------
(defun MODER ()
   (repeat (length mlst)			; Ripete per tutta la lunghezza della lista
      (setvar (caar mlst) (cadar mlst))		; Estrae ed imposta "nome variabile" e valore
      (setq mlst (cdr mlst))			; Accorcia lista eliminando primo elemento
   )
)
; ----------------------------------
; Error handler (gestione errore)
; ----------------------------------
(defun b_err (st)
  (moder)					; Ripristina variabili memorizzate
  (setq *error* olderr)				; Restore old *error* handler

;;;;  Inserire qui altre variabili di sistema o comandi da eseguire prima dell'uscita

  (princ)					; Esce senza nil
)
;
;-----------------------------
;	INSPUNTO
;-----------------------------
;	ptp	= punto precedente:
;			Se PTP = 0			=>	NON c'e' linea elastica
;			Se PTP = (coord. di un punto)	=>	Viene inserito quel punto come
;								riferimento e compare una linea
;								elastica che parte da quel punto
;	msg	= Stringa domanda		- es. "\nInser. punto: "
;
;	La variabile in uscita e' PT (lista)
;
;
(defun INSPUNTO (ptp msg)
;
   (if (= ptp 0)				; Se PTP e' = 0 ...
	(setq pt (getpoint msg))		; ... si inserisce il primo punto ...
	(setq pt (getpoint ptp msg))		; ... altrimenti si inserisce un punto successivo
   )						; Fine di IF PTP
)						; Fine di INSPUNTO
;
;
;-----------------------------
;	INSVERT
;-----------------------------
;	vep	= punto precedente:
;			VEP = (coord. di un punto)	=>	Viene inserito quel punto come
;								riferimento e compare un rettangolo
;								elastico che parte da quel punto
;	msg	= Stringa domanda		- es. "\nInser. vertice opposto : "
;
;	La variabile in uscita e' VE (lista)
;
;
(defun INSVERT (vep msg)
;
	(setq ve (getcorner vep msg))		; Inserisce il vertice opposto del rettangolo
)						; Fine di INSVERT

;
;-----------------------------
;	INSTRING
;-----------------------------
;	tipo	= se valore nullo (nil) non permette l'inserimento di spazi (lo spazio = a invio)
;		  se ha un qualunque valore <> da nil, accetta gli spazi e si conclude la frase
;		  solo utilizzando il tasto Invio.
;
;	msg	= Stringa domanda		- es. "\nInserisci una frase : "
;
;
(defun INSTRING (tipo msg)
;
	(setq stringa (getstring tipo msg))	; Inserisce la stringa
)						; Fine di INSTRING
;
;
;
;----------------------------
;        Input Dati
;----------------------------
(defun INDATI ()
;
   (graphscr)					; Passa allo schermo grafico (se si fosse in quello testo)
   (setvar "highlight" 1)			; Imposta ad "on" la visualizzaz. degli elem. selezionati
   (modes '("HIGHLIGHT" "OSMODE" "LIMCHECK" "CMDECHO")); Lista di variabili da ripristinare all'uscita
   (setvar "osmode" 0) (setvar "limcheck" 0)	; Variabili impostate ad "off"
   (setvar "cmdecho" 0)				; Idem
;
; - - - - - - - - - - - - - - - - - - - - - - - - - -
;	Richiamo Sub. Inspunto (lista)
; - - - - - - - - - - - - - - - - - - - - - - - - - -
;
   (setq ptp 0)					; Inizializza variabile ptp
   (INSPUNTO ptp "\nInserisci il primo punto : ")	; Richiamo sub. Inspunto
   (setq pt1 pt)				; Viene aggiorn. default
;
   (setq ptp pt1)				; Variabile ptp diventa = a primo punto (pt1)
   (INSPUNTO ptp "\nInserisci il secondo punto : ")	; Richiamo sub. Inspunto
   (setq pt2 pt)				; Viene aggiorn. default
;
   (prompt "\npt1 = ")(prin1 pt1)		; Stampa il risultato sulla riga comando
   (prompt "\npt2 = ")(prin1 pt2)		; Stampa il risultato sulla riga comando
;
   (command "_line" pt1 pt2 "")			; Traccia una linea fra i due punti
;
; Il comando _LINE (comando INGLESE preceduto dal tratto basso) permette di utilizzare questo comando,
; sia su versioni di Autocad Inglese che su versioni in Italiano
;
;
; - - - - - - - - - - - - - - - - - - - - - - - - - -
;	Richiamo Sub. Insvert (lista)
; - - - - - - - - - - - - - - - - - - - - - - - - - -
;
   (setq ptp 0)					; Inizializza variabile vep
   (INSPUNTO ptp "\nInserisci il primo vertice : ")	; Richiamo sub. Inspunto
   (setq ve1 pt)				; Viene aggiorn. default
;
   (setq vep ve1)				; Variabile vep diventa = a primo punto (ve1)
   (INSVERT vep "\nInserisci il vertice opposto : ")	; Richiamo sub. Insvert
   (setq ve2 ve)				; Viene aggiorn. default
;
   (prompt "\nve1 = ")(prin1 ve1)		; Stampa il risultato sulla riga comando
   (prompt "\nve2 = ")(prin1 ve2)		; Stampa il risultato sulla riga comando
;
   (command "_pline" ve1 ".y" ve2 ve1 ve2 ".x" ve2 ve1 "_c")	; Traccia il rettangolo
;
; Il comando _PLINE (comando INGLESE preceduto dal tratto basso) permette di utilizzare questo comando,
; sia su versioni di Autocad Inglese che su versioni in Italiano.
;
; Questo comando viene utilizzato con i filtri delle coordinate per poter tracciare un rettangolo:
; Dopo il comando "_PLINE" troviamo VE1 (il primo vertice del rettangolo).
; - Poi viene utilizzata solo la coord. Y del vertice VE2 (".y" VE2), mentre la restante coord. x e quella di VE1.
; - Il terzo vertice immesso e' VE2.
; - Poi si prende la coord. X di VE2 (".x" VE2), mentre per la coord. y si ricorre a VE1 (Quarto vertice).
; - Infine si chiude il rettangolo ("_C").
;
;  In questo modo, da 2 vertici VE1 e VE2, e' stato possibile ricavare i 4 punti per formare il rettangolo.
;
;


;
; - - - - - - - - - - - - - - - - - - - - - - - - - -
;	Richiami alla Sub. Instring
; - - - - - - - - - - - - - - - - - - - - - - - - - -
;
  (alert "\nINSERISCI UNA FRASE DI 2 O PIU' PAROLE\nE TERMINALA CON 'INVIO'")
  (instring 1 "\n... ")				; Richiamo sub.
  (alert (strcat "\nHAI SCRITTO LA FRASE\n" stringa)); Visualizza la frase
;
  (alert "\nINSERISCI UNA FRASE DI 2 O PIU' PAROLE")
  (instring nil "\n... ")			; Richiamo sub.
  (alert (strcat "\nHAI POTUTO SCRIVERE SOLO LA PAROLA:\n" stringa
		 "\nPERCHE' LO SPAZIO E' STATO CONSIDERATO COME 'INVIO'")
  )
  (alert "\nQUESTA OPZIONE E' UTILE QUANDO SI VUOLE\nASSEGNARE SOLO UNA PAROLA AD UNA VARIABILE")
;
  (alert "\nINSERISCI UNA FRASE DI 2 O PIU' PAROLE\nMA RACCHIUDILA FRA PARENTESI")
  (instring nil "\n... ")			; Richiamo sub.
  (alert (strcat "\nHAI SCRITTO LA FRASE:\n" stringa)); Visualizza la frase
  (alert "\nLE FRASI FRA PARENTESI VENGONO CONSIDERATE\nUN' UNICA STRINGA")
;
)						; Fine di INDATI
;
;
;--------------------------------------------------
;     P R O G R A M M A     P R I N C I P A L E
;--------------------------------------------------
(defun C:TUTORIAL2 (/ a mlst)
;
   (setq olderr *error* *error* b_err)		; Richiama gestore errori
;
   (indati)					; Richiama sub. inserimento dati
;
;	Inserire qui il richiamo ad altre sub. o istruzioni
;
   (moder)					; Ripristina variabili a termine programma
;
   (setq olderr *error*)			; Ripristina in caso di errore
   (princ)					; Esce senza stampare nil su riga comando
)


